﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Windows;
using System.Windows.Threading;
using Arction.Wpf.SemibindableCharting;
using Arction.Wpf.SemibindableCharting.SeriesXY;
using Arction.Wpf.SemibindableCharting.Views.ViewXY;

namespace HeatmapTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            CreateChart();
        }

        void CreateChart()
        {
            m_chart.ViewXY.IntensityGridSeries[0].MouseTraceCellChanged += new IntensitySeriesBase.MouseTraceCellChangedHandler(heatmap_MouseTraceCellChanged);
        }

        void heatmap_MouseTraceCellChanged(IntensitySeriesBase sender, int mouseX, int mouseY, int newCellColumn, int newCellRow, int nearestDataColumnIndex, int nearestDataRowIndex, IntensityPoint nearestCellCorner, float nearestCellCornerCoordX, float nearestCellCornerCoordY)
        {
            Debug.WriteLine($"Mouse trace [{newCellColumn}][{newCellRow}] = {sender.Data[newCellColumn, newCellRow].Value:0.0}");
        }

        //Call from VM
        public void BeginUpdateChart()=> m_chart.BeginUpdate();

        public void EndUpdateChart()
        {
            m_chart.ViewXY.IntensityGridSeries[0].InvalidateValuesDataOnly();
            m_chart.EndUpdate();
        }
    }
}
